//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
#ifndef ADD_FAVORITES_DLG_HPP
#define ADD_FAVORITES_DLG_HPP

#ifndef NO_FAVORITES

// add favorites dialog 
class CAddFavoritesDlg : public CDialogImpl <CAddFavoritesDlg>
{
public:
	CAddFavoritesDlg() {}
	~CAddFavoritesDlg();

	BEGIN_MSG_MAP(CAddFavoritesDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		
		COMMAND_HANDLER (IDC_CREATE_IN, BN_CLICKED, OnSelectFolder)
		COMMAND_HANDLER (IDOK, BN_CLICKED, OnOk)
		COMMAND_HANDLER (IDCANCEL, BN_CLICKED, OnCancel)
	END_MSG_MAP()

	enum { IDD = IDD_ADD_FAV_DLG };

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnOk (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnSelectFolder (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnCancel (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	BOOL Startup(CMainWnd* pMainWnd, TCHAR* pszTitle, HMENU hFavMenu);
	BOOL IsRegistryChanged ();

private:
	CWindow   m_wndEdit;
	CMainWnd* m_wndMainWnd; // pointer to the main window class
	HMENU     m_hFavMenu;
	TCHAR*    m_pszTitle;
	TCHAR     m_szPath[MAX_REGKEY_LEN];
	BOOL      m_bRegistryChanged;

	BOOL StoreFavorite(TCHAR* pszFavorite, TCHAR* szUrl);
	BOOL InsertFavoriteIntoMenu(TCHAR* pszFavorite);

};

#endif // ndef NO_FAVORITES
#endif
