//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
#ifndef __FAVHELPER_H__
#define __FAVHELPER_H__
#ifndef NO_FAVORITES

#define MODE_ORGANIZEFAV 1
#define MODE_FAVFOLDERS  2

class CFavoritesHelper
{
	public:
		CFavoritesHelper () {};
		~CFavoritesHelper ();

		BOOL InitHelper (HINSTANCE hInstance,
						 CWindow *pTreeCtrl,
						 IFavStorage *pFavStorage,
						 int nMode);
		BOOL InitTreeViewImageLists();
		DWORD PopulateTreeControl (LPTSTR szPath,HTREEITEM hTreeItem=NULL,DWORD level=0);
		BOOL IsLeafItem (HTREEITEM hTreeItem, TVITEM &tv);
		BOOL GetParentItem (HTREEITEM hTreeItem, TVITEM &tv);
		BOOL SetItemInfo (HTREEITEM hTreeItem, LPCTSTR szRegKey);
		BOOL AddIconToImgList (UINT uiIcoID, int& nIcoIndex);
		HTREEITEM AddItemToTree(LPTSTR lpszItem, 
								int nLevel, 
								HTREEITEM hPrevItem, 
								HTREEITEM hParent, 
								BOOL bAppendLast=FALSE,
								BOOL bFolder=FALSE);
		HTREEITEM GetRootItem () { return m_hRootItem;}
		HTREEITEM GetNewItem  () { return m_hNewItem;}
		void SetNewItem (HTREEITEM hItem) {m_hNewItem = hItem;}
		void ShowErrDialog (HWND hWnd, int nID);

		LRESULT CreateFolder (WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
		LRESULT BeginEditLabel(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
		LRESULT EndEditLabel(int idCtrl, LPNMHDR pnmh, 
							 BOOL& bHandled, BOOL& bRename, LPTSTR szSrcPath=NULL);
		BOOL RenameItem (LPTSTR szSrcPath, LPTSTR szNewItem);

	private:
		CWindow      *m_pTreeCtrl;
		IFavStorage  *m_pFavStorage;
		HIMAGELIST   m_hIml;
		HINSTANCE    g_hInstance;
		HTREEITEM    m_hRootItem;
		HTREEITEM    m_hNewItem;
		int          m_nMode;
		int          m_nOpenFolder;
		int          m_nCloseFolder;
		int          m_nURL;
};

#endif // NO_FAVORITES
#endif // __FAVHELPER_H__

