//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
#ifndef __REGFAVORITES_H__
#define __REGFAVORITES_H__

#ifndef NO_FAVORITES

#include "FavStorageIfc.h"

class CRegFavorites : public IFavStorage
{
public:

	CRegFavorites ();
	~CRegFavorites ();

	LPTSTR GetRootFolder ();
	LRESULT GetFolderInfo (LPTSTR szFolder, 
						   DWORD &dwSubFolders,
						   DWORD &dwFavorites);
	LPTSTR GetURL (LPTSTR szFavorite);
	BOOL IsFavAvailable ();
	LRESULT EnumFolders (LPTSTR szPath,
						 DWORD dwIdx,
						 LPTSTR szBuffer,
						 DWORD &dwBufLen);
	LRESULT CreateFavorite (LPTSTR szPath,
						    LPTSTR szFavTitle,
						    LPTSTR szURL);
	LRESULT CopyFolder (LPTSTR szSourcePath,
						LPTSTR szDestPath);
	LRESULT DeleteFolder (LPTSTR szPath);
	LRESULT Rename (LPTSTR szOldName, LPTSTR szNewName);
	BOOL IsDuplicateFavorite (LPTSTR szPath,
							  LPTSTR szFavTitle);
private:

	BOOL    m_bRename;
	LRESULT MoveKeys (LPTSTR szSourceKey, LPTSTR szDestinKey);
	LRESULT MoveRegValues (HKEY hKeySrc, HKEY hKeyDest);
};

#endif // ndef NO_FAVORITES
#endif
