//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
#ifndef REG_KEYS_H
#define REG_KEYS_H

#define REG_KEY_INTERNET_EXPLORER	TEXT("Software\\Microsoft\\Internet Explorer")
#define REG_KEY_BROWSER_TYPED_URLS	REG_KEY_INTERNET_EXPLORER TEXT("\\TypedURLs")
#define REG_KEY_BROWSER_OPTIONS		REG_KEY_INTERNET_EXPLORER TEXT("\\Main")
#define REG_KEY_BROWSER_FAVORITES	REG_KEY_INTERNET_EXPLORER TEXT("\\Favorites")
#define REG_KEY_BROWSER_URL			TEXT("URL")
#define REG_KEY_BROWSER_FONTSIZE	TEXT("Software\\Microsoft\\Internet Explorer\\International\\")

// This key contains the registry's copy of the browser cache (actually, it
// just contains the cookie: cache entries).  This allows the cache to be
// persisted across power loss by being saved to flash whenever an application
// calls RegFlushKey (which calls the OemWriteRegistry function).
#define REG_KEY_BROWSER_CACHE		REG_KEY_INTERNET_EXPLORER TEXT("\\Cache")

#define REG_VAL_PERSISTENT_CACHE		TEXT("Persistent Cache")
#define REG_VAL_ENABLE_FAVORITES		TEXT("Favorites")
#define REG_VAL_CACHE_BACKUP_INTERVAL	TEXT("Cache Backup")
#define REG_VAL_STATUS_ANIMATION		TEXT("Status Animation")
#define REG_VAL_FONTSIZE				TEXT("IEFontSize")

#endif // REG_KEYS_H
